<?php

/**
 * EXHIBIT A. Common Public Attribution License Version 1.0
 * The contents of this file are subject to the Common Public Attribution License Version 1.0 (the “License”);
 * you may not use this file except in compliance with the License. You may obtain a copy of the License at
 * http://www.oxwall.org/license.php. The License is based on the Mozilla Public License Version 1.1
 * but Sections 14 and 15 have been added to cover use of software over a computer network and provide for
 * limited attribution for the Original Developer. In addition, Exhibit A has been modified to be consistent
 * with Exhibit B. Software distributed under the License is distributed on an “AS IS” basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the specific language
 * governing rights and limitations under the License. The Original Code is Oxwall software.
 * The Initial Developer of the Original Code is Skalfa LLC (http://www.skalfa.com/).
 * All portions of the code written by Skalfa LLC are Copyright (c) 2009. All Rights Reserved.

 * EXHIBIT B. Attribution Information
 * Attribution Copyright Notice: Copyright 2009 Skalfa LLC. All rights reserved.
 * Attribution Phrase (not exceeding 10 words): Powered by Oxwall community software
 * Attribution URL: http://www.oxwall.org/
 * Graphic Image as provided in the Covered Code.
 * Display of Attribution Information is required in Larger Works which are defined in the CPAL as a work
 * which combines Covered Code or portions thereof with code not governed by the terms of the CPAL.
 */

/**
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_system_plugins.base.components
 * @since 1.0
 */
abstract class BASE_CMP_Users extends OW_Component
{

    abstract public  function getFields($userIdList);    
    
    public function __construct( $list, $itemCount, $rpp, $isShowOnline = true )
    {
        parent::__construct();

        $this->setTemplate( OW::getPluginManager()->getPlugin('base')->getCmpViewDir().'users.html' );
        
        $this->process($list, $isShowOnline);

        $page = (!empty($_GET['page']) && intval($_GET['page']) > 0 ) ? $_GET['page'] : 1;

        $this->addComponent('paging', new BASE_CMP_Paging($page, ceil($itemCount / $rpp), 5));
    }

    private function process( $list, $isShowOnline )
    {
        $service = BOL_UserService::getInstance();

        $idList = array();

        $userList = array();

        foreach ( $list as $dto )
        {
            $userList[] = array(
                'dto' => $dto
            );

            $idList[] = $dto->getId();
        }

        $usernameList = array();
        $displayNameList = array();
        $avatarList = array();

        
        $onlineInfo = array();

        $questionList = array();
        
        if ( !empty($idList) )
        {
            $displayNameList = $service->getDisplayNamesForList($idList);
            $usernameList = $service->getUserNamesForList($idList);
            $avatarList = BOL_AvatarService::getInstance()->getAvatarsUrlList($idList);

/*            $qs = array();

            $qBdate = BOL_QuestionService::getInstance()->findQuestionByName('birthdate', 'sex');

            if ( $qBdate->onView )
                $qs[] = 'birthdate';

            $qSex = BOL_QuestionService::getInstance()->findQuestionByName('sex');

            if ( $qSex->onView )
                $qs[] = 'sex';

            $questionList = BOL_QuestionService::getInstance()->getQuestionData($idList, $qs);
*/            
            if ( $isShowOnline )
            {
                $onlineInfo = $service->findOnlineStatusForUserList($idList);
            }
        }

        $fields = array();

/*
        foreach ( $questionList as $uid => $q )
        {
            
	        $date = UTIL_DateTime::parseDate( $q['birthdate'], UTIL_DateTime::MYSQL_DATETIME_DATE_FORMAT );            
            
            $dinfo = date_parse($q['birthdate']);
            
            $birthdate = '';
            
            if ( intval(date('d')) + 1 == intval($dinfo['day']) )
            {
                $questionList[$uid]['birthday'] = 'Tomorrow';
                
                $birthdate = 'Tomorrow';
            }
            else if ( intval(date('d')) + 1 == intval($dinfo['day']) )
            {
                $questionList[$uid]['birthday'] = 'Today';
                
                $birthdate = 'Today';
            }
            else{
                $birthdate = UTIL_DateTime::formatBirthdate($dinfo['year'], $dinfo['month'], $dinfo['day']);
            }
            
            $fields[$uid] = array(
                array(
                	'label' => '',
                    'value' => BOL_QuestionService::getInstance()->getQuestionValueLang('sex', $q['sex']) .' '.UTIL_DateTime::getAge($date['year'], $date['month'], $date['day'])
                ),
                array(
                    'label' => 'Birthday: ',
                    'value' => $birthdate
                )
            );
        }

 */
        
        
        $this->assign( 'fields', $this->getFields($idList) );

        $this->assign('questionList', $questionList);

        $this->assign('usernameList', $usernameList);
        $this->assign('avatarList', $avatarList);
        $this->assign('displayNameList', $displayNameList);
        $this->assign('onlineInfo', $onlineInfo);

        $this->assign('list', $userList);
    }
}